<?php
/*---------------------------------------------------------
 *   Similar Topics Module for LiveStreet Engine.
 *   (c) 2009 asdx.
 *---------------------------------------------------------
 *   LiveStreet Engine Social Networking
 *   Copyright © 2008 Mzhelskiy Maxim
 *---------------------------------------------------------
 *   GNU General Public License, version 2:
 *   http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *---------------------------------------------------------
 */

class Mapper_SimilarTopics extends Mapper {

	public function GetSimilarTopics($sId, $sTitleTags, $iCurrentUserId=-1) {

		$sWhere = "and t.topic_id <> ?d and match(t.topic_title,t.topic_tags) against (?) > ?d";
		
		/**
		 * запрос немного оптимизирован, почуствуй разницу :)
		 * на самом деле его еще можно ускорить - во вложеном запросе убрать условие по типу блога и вынести его в JOIN + изменив фильтр(вынести из него тип блога)
		 * и вообще от фильтра нужно избавляться, т.к. эта универсальной сказывается на быстродействии из-за разных комбинаций ключей
		 * 
		 * при таком запросе приходиться отдельно запрашивать общее число записей
		 */
		$sql = "
				SELECT 
					t_fast.*, 
					tc.*,
					u.user_login as user_login,
					IF(tv.topic_id IS NULL,0,1) as user_is_vote,
					tv.vote_delta as user_vote_delta,
					IF(tqv.topic_id IS NULL,0,1) as user_question_is_vote,
					bu.is_moderator as user_is_blog_moderator,
					bu.is_administrator as user_is_blog_administrator,
					IF(tr.comment_count_last IS NULL,t_fast.topic_count_comment,t_fast.topic_count_comment-tr.comment_count_last) as count_comment_new,
					IF(ft.topic_id IS NULL,0,1) as topic_is_favourite
				FROM (
					SELECT 
						t.*, match(t.topic_title,t.topic_tags) against (?) as score,
						b.blog_title as blog_title,
						b.blog_type as blog_type,
						b.blog_url as blog_url,
						b.user_owner_id as blog_owner_id
					FROM 
						".DB_TABLE_TOPIC." as t,
						".DB_TABLE_BLOG." as b
					WHERE 
						1=1
					
						".$sWhere."
					
						AND
						t.blog_id=b.blog_id
					ORDER by score desc, t.topic_date_add desc
					LIMIT ?d
				) as t_fast
				JOIN ".DB_TABLE_USER." AS u ON t_fast.user_id=u.user_id
				LEFT JOIN (
						SELECT
							topic_id,
							vote_delta
						FROM ".DB_TABLE_TOPIC_VOTE." 
						WHERE user_voter_id = ?d
					) AS tv ON t_fast.topic_id=tv.topic_id 
				LEFT JOIN (
						SELECT
							topic_id
						FROM ".DB_TABLE_FAVOURITE_TOPIC." 
						WHERE user_id = ?d
					) AS ft ON t_fast.topic_id=ft.topic_id
				LEFT JOIN (
						SELECT
							topic_id,
							comment_count_last
						FROM ".DB_TABLE_TOPIC_READ." 
						WHERE user_id = ?d
					) AS tr ON t_fast.topic_id=tr.topic_id
				LEFT JOIN (
						SELECT
							topic_id
						FROM ".DB_TABLE_TOPIC_QUESTION_VOTE." 
						WHERE user_voter_id = ?d
					) AS tqv ON t_fast.topic_id=tqv.topic_id
				LEFT JOIN (
						SELECT
							is_moderator,
							is_administrator,
							blog_id
						FROM ".DB_TABLE_BLOG_USER." 
						WHERE user_id = ?d
					) AS bu ON t_fast.blog_id=bu.blog_id
				JOIN  ".DB_TABLE_TOPIC_CONTENT." AS tc ON t_fast.topic_id=tc.topic_id
				order by t_fast.topic_date_add desc
				;";
		
		$aTopics=array();
		if ($aRows=$this->oDb->select($sql, $sTitleTags, $sId, $sTitleTags, SIMILARTOPICS_SCORE, SIMILARTOPICS_COUNT, $iCurrentUserId,$iCurrentUserId,$iCurrentUserId,$iCurrentUserId,$iCurrentUserId)) {
			foreach ($aRows as $aTopic) {
				$aTopics[]=new TopicEntity_Topic($aTopic);
			}
		}
		//$iCount=sizeof($aTopics); //$this->GetCountTopics($aFilter);		
		return $aTopics;
	}
}
?>
